<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createChecklistTemplateResponse StructType
 * @subpackage Structs
 */
class CreateChecklistTemplateResponse extends AbstractStructBase
{
    /**
     * The checklistTemplate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ChecklistTemplateType[]
     */
    public $checklistTemplate;
    /**
     * The error
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ErrorType[]
     */
    public $error;
    /**
     * Constructor method for createChecklistTemplateResponse
     * @uses CreateChecklistTemplateResponse::setChecklistTemplate()
     * @uses CreateChecklistTemplateResponse::setError()
     * @param \StructType\ChecklistTemplateType[] $checklistTemplate
     * @param \StructType\ErrorType[] $error
     */
    public function __construct(array $checklistTemplate = array(), array $error = array())
    {
        $this
            ->setChecklistTemplate($checklistTemplate)
            ->setError($error);
    }
    /**
     * Get checklistTemplate value
     * @return \StructType\ChecklistTemplateType[]|null
     */
    public function getChecklistTemplate()
    {
        return $this->checklistTemplate;
    }
    /**
     * This method is responsible for validating the values passed to the setChecklistTemplate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChecklistTemplate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChecklistTemplateForArrayConstraintsFromSetChecklistTemplate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createChecklistTemplateResponseChecklistTemplateItem) {
            // validation for constraint: itemType
            if (!$createChecklistTemplateResponseChecklistTemplateItem instanceof \StructType\ChecklistTemplateType) {
                $invalidValues[] = is_object($createChecklistTemplateResponseChecklistTemplateItem) ? get_class($createChecklistTemplateResponseChecklistTemplateItem) : sprintf('%s(%s)', gettype($createChecklistTemplateResponseChecklistTemplateItem), var_export($createChecklistTemplateResponseChecklistTemplateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The checklistTemplate property can only contain items of type \StructType\ChecklistTemplateType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set checklistTemplate value
     * @throws \InvalidArgumentException
     * @param \StructType\ChecklistTemplateType[] $checklistTemplate
     * @return \StructType\CreateChecklistTemplateResponse
     */
    public function setChecklistTemplate(array $checklistTemplate = array())
    {
        // validation for constraint: array
        if ('' !== ($checklistTemplateArrayErrorMessage = self::validateChecklistTemplateForArrayConstraintsFromSetChecklistTemplate($checklistTemplate))) {
            throw new \InvalidArgumentException($checklistTemplateArrayErrorMessage, __LINE__);
        }
        $this->checklistTemplate = $checklistTemplate;
        return $this;
    }
    /**
     * Add item to checklistTemplate value
     * @throws \InvalidArgumentException
     * @param \StructType\ChecklistTemplateType $item
     * @return \StructType\CreateChecklistTemplateResponse
     */
    public function addToChecklistTemplate(\StructType\ChecklistTemplateType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ChecklistTemplateType) {
            throw new \InvalidArgumentException(sprintf('The checklistTemplate property can only contain items of type \StructType\ChecklistTemplateType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->checklistTemplate[] = $item;
        return $this;
    }
    /**
     * Get error value
     * @return \StructType\ErrorType[]|null
     */
    public function getError()
    {
        return $this->error;
    }
    /**
     * This method is responsible for validating the values passed to the setError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorForArrayConstraintsFromSetError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createChecklistTemplateResponseErrorItem) {
            // validation for constraint: itemType
            if (!$createChecklistTemplateResponseErrorItem instanceof \StructType\ErrorType) {
                $invalidValues[] = is_object($createChecklistTemplateResponseErrorItem) ? get_class($createChecklistTemplateResponseErrorItem) : sprintf('%s(%s)', gettype($createChecklistTemplateResponseErrorItem), var_export($createChecklistTemplateResponseErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The error property can only contain items of type \StructType\ErrorType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set error value
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorType[] $error
     * @return \StructType\CreateChecklistTemplateResponse
     */
    public function setError(array $error = array())
    {
        // validation for constraint: array
        if ('' !== ($errorArrayErrorMessage = self::validateErrorForArrayConstraintsFromSetError($error))) {
            throw new \InvalidArgumentException($errorArrayErrorMessage, __LINE__);
        }
        $this->error = $error;
        return $this;
    }
    /**
     * Add item to error value
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorType $item
     * @return \StructType\CreateChecklistTemplateResponse
     */
    public function addToError(\StructType\ErrorType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ErrorType) {
            throw new \InvalidArgumentException(sprintf('The error property can only contain items of type \StructType\ErrorType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->error[] = $item;
        return $this;
    }
}
