<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for createParcelContent StructType
 * @subpackage Structs
 */
class CreateParcelContent extends AbstractStructBase
{
    /**
     * The parcelContent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\ParcelContentType[]
     */
    public $parcelContent;
    /**
     * Constructor method for createParcelContent
     * @uses CreateParcelContent::setParcelContent()
     * @param \StructType\ParcelContentType[] $parcelContent
     */
    public function __construct(array $parcelContent = array())
    {
        $this
            ->setParcelContent($parcelContent);
    }
    /**
     * Get parcelContent value
     * @return \StructType\ParcelContentType[]
     */
    public function getParcelContent()
    {
        return $this->parcelContent;
    }
    /**
     * This method is responsible for validating the values passed to the setParcelContent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setParcelContent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateParcelContentForArrayConstraintsFromSetParcelContent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createParcelContentParcelContentItem) {
            // validation for constraint: itemType
            if (!$createParcelContentParcelContentItem instanceof \StructType\ParcelContentType) {
                $invalidValues[] = is_object($createParcelContentParcelContentItem) ? get_class($createParcelContentParcelContentItem) : sprintf('%s(%s)', gettype($createParcelContentParcelContentItem), var_export($createParcelContentParcelContentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The parcelContent property can only contain items of type \StructType\ParcelContentType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set parcelContent value
     * @throws \InvalidArgumentException
     * @param \StructType\ParcelContentType[] $parcelContent
     * @return \StructType\CreateParcelContent
     */
    public function setParcelContent(array $parcelContent = array())
    {
        // validation for constraint: array
        if ('' !== ($parcelContentArrayErrorMessage = self::validateParcelContentForArrayConstraintsFromSetParcelContent($parcelContent))) {
            throw new \InvalidArgumentException($parcelContentArrayErrorMessage, __LINE__);
        }
        $this->parcelContent = $parcelContent;
        return $this;
    }
    /**
     * Add item to parcelContent value
     * @throws \InvalidArgumentException
     * @param \StructType\ParcelContentType $item
     * @return \StructType\CreateParcelContent
     */
    public function addToParcelContent(\StructType\ParcelContentType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ParcelContentType) {
            throw new \InvalidArgumentException(sprintf('The parcelContent property can only contain items of type \StructType\ParcelContentType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->parcelContent[] = $item;
        return $this;
    }
}
