<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getAdditionalActivitiesListResponse StructType
 * @subpackage Structs
 */
class GetAdditionalActivitiesListResponse extends AbstractStructBase
{
    /**
     * The additionalActivity
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AdditionalActivityType[]
     */
    public $additionalActivity;
    /**
     * The error
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ErrorType[]
     */
    public $error;
    /**
     * Constructor method for getAdditionalActivitiesListResponse
     * @uses GetAdditionalActivitiesListResponse::setAdditionalActivity()
     * @uses GetAdditionalActivitiesListResponse::setError()
     * @param \StructType\AdditionalActivityType[] $additionalActivity
     * @param \StructType\ErrorType[] $error
     */
    public function __construct(array $additionalActivity = array(), array $error = array())
    {
        $this
            ->setAdditionalActivity($additionalActivity)
            ->setError($error);
    }
    /**
     * Get additionalActivity value
     * @return \StructType\AdditionalActivityType[]|null
     */
    public function getAdditionalActivity()
    {
        return $this->additionalActivity;
    }
    /**
     * This method is responsible for validating the values passed to the setAdditionalActivity method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdditionalActivity method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdditionalActivityForArrayConstraintsFromSetAdditionalActivity(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getAdditionalActivitiesListResponseAdditionalActivityItem) {
            // validation for constraint: itemType
            if (!$getAdditionalActivitiesListResponseAdditionalActivityItem instanceof \StructType\AdditionalActivityType) {
                $invalidValues[] = is_object($getAdditionalActivitiesListResponseAdditionalActivityItem) ? get_class($getAdditionalActivitiesListResponseAdditionalActivityItem) : sprintf('%s(%s)', gettype($getAdditionalActivitiesListResponseAdditionalActivityItem), var_export($getAdditionalActivitiesListResponseAdditionalActivityItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The additionalActivity property can only contain items of type \StructType\AdditionalActivityType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set additionalActivity value
     * @throws \InvalidArgumentException
     * @param \StructType\AdditionalActivityType[] $additionalActivity
     * @return \StructType\GetAdditionalActivitiesListResponse
     */
    public function setAdditionalActivity(array $additionalActivity = array())
    {
        // validation for constraint: array
        if ('' !== ($additionalActivityArrayErrorMessage = self::validateAdditionalActivityForArrayConstraintsFromSetAdditionalActivity($additionalActivity))) {
            throw new \InvalidArgumentException($additionalActivityArrayErrorMessage, __LINE__);
        }
        $this->additionalActivity = $additionalActivity;
        return $this;
    }
    /**
     * Add item to additionalActivity value
     * @throws \InvalidArgumentException
     * @param \StructType\AdditionalActivityType $item
     * @return \StructType\GetAdditionalActivitiesListResponse
     */
    public function addToAdditionalActivity(\StructType\AdditionalActivityType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdditionalActivityType) {
            throw new \InvalidArgumentException(sprintf('The additionalActivity property can only contain items of type \StructType\AdditionalActivityType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->additionalActivity[] = $item;
        return $this;
    }
    /**
     * Get error value
     * @return \StructType\ErrorType[]|null
     */
    public function getError()
    {
        return $this->error;
    }
    /**
     * This method is responsible for validating the values passed to the setError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorForArrayConstraintsFromSetError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getAdditionalActivitiesListResponseErrorItem) {
            // validation for constraint: itemType
            if (!$getAdditionalActivitiesListResponseErrorItem instanceof \StructType\ErrorType) {
                $invalidValues[] = is_object($getAdditionalActivitiesListResponseErrorItem) ? get_class($getAdditionalActivitiesListResponseErrorItem) : sprintf('%s(%s)', gettype($getAdditionalActivitiesListResponseErrorItem), var_export($getAdditionalActivitiesListResponseErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The error property can only contain items of type \StructType\ErrorType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set error value
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorType[] $error
     * @return \StructType\GetAdditionalActivitiesListResponse
     */
    public function setError(array $error = array())
    {
        // validation for constraint: array
        if ('' !== ($errorArrayErrorMessage = self::validateErrorForArrayConstraintsFromSetError($error))) {
            throw new \InvalidArgumentException($errorArrayErrorMessage, __LINE__);
        }
        $this->error = $error;
        return $this;
    }
    /**
     * Add item to error value
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorType $item
     * @return \StructType\GetAdditionalActivitiesListResponse
     */
    public function addToError(\StructType\ErrorType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ErrorType) {
            throw new \InvalidArgumentException(sprintf('The error property can only contain items of type \StructType\ErrorType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->error[] = $item;
        return $this;
    }
}
