<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getReklamacje StructType
 * @subpackage Structs
 */
class GetReklamacje extends AbstractStructBase
{
    /**
     * The dataRozpatrzenia
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dataRozpatrzenia;
    /**
     * The guidPrzesylki
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - length: 32
     * - maxOccurs: 1
     * - minOccurs: 0
     * - whiteSpace: collapse
     * @var string
     */
    public $guidPrzesylki;
    /**
     * The dataZlozenia
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DataZlozeniaType
     */
    public $dataZlozenia;
    /**
     * Constructor method for getReklamacje
     * @uses GetReklamacje::setDataRozpatrzenia()
     * @uses GetReklamacje::setGuidPrzesylki()
     * @uses GetReklamacje::setDataZlozenia()
     * @param string $dataRozpatrzenia
     * @param string $guidPrzesylki
     * @param \StructType\DataZlozeniaType $dataZlozenia
     */
    public function __construct($dataRozpatrzenia = null, $guidPrzesylki = null, \StructType\DataZlozeniaType $dataZlozenia = null)
    {
        $this
            ->setDataRozpatrzenia($dataRozpatrzenia)
            ->setGuidPrzesylki($guidPrzesylki)
            ->setDataZlozenia($dataZlozenia);
    }
    /**
     * Get dataRozpatrzenia value
     * @return string|null
     */
    public function getDataRozpatrzenia()
    {
        return $this->dataRozpatrzenia;
    }
    /**
     * Set dataRozpatrzenia value
     * @param string $dataRozpatrzenia
     * @return \StructType\GetReklamacje
     */
    public function setDataRozpatrzenia($dataRozpatrzenia = null)
    {
        // validation for constraint: string
        if (!is_null($dataRozpatrzenia) && !is_string($dataRozpatrzenia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dataRozpatrzenia, true), gettype($dataRozpatrzenia)), __LINE__);
        }
        $this->dataRozpatrzenia = $dataRozpatrzenia;
        return $this;
    }
    /**
     * Get guidPrzesylki value
     * @return string|null
     */
    public function getGuidPrzesylki()
    {
        return $this->guidPrzesylki;
    }
    /**
     * Set guidPrzesylki value
     * @param string $guidPrzesylki
     * @return \StructType\GetReklamacje
     */
    public function setGuidPrzesylki($guidPrzesylki = null)
    {
        // validation for constraint: string
        if (!is_null($guidPrzesylki) && !is_string($guidPrzesylki)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($guidPrzesylki, true), gettype($guidPrzesylki)), __LINE__);
        }
        // validation for constraint: length(32)
        if (!is_null($guidPrzesylki) && mb_strlen($guidPrzesylki) !== 32) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be equal to 32', mb_strlen($guidPrzesylki)), __LINE__);
        }
        $this->guidPrzesylki = $guidPrzesylki;
        return $this;
    }
    /**
     * Get dataZlozenia value
     * @return \StructType\DataZlozeniaType|null
     */
    public function getDataZlozenia()
    {
        return $this->dataZlozenia;
    }
    /**
     * Set dataZlozenia value
     * @param \StructType\DataZlozeniaType $dataZlozenia
     * @return \StructType\GetReklamacje
     */
    public function setDataZlozenia(\StructType\DataZlozeniaType $dataZlozenia = null)
    {
        $this->dataZlozenia = $dataZlozenia;
        return $this;
    }
}
