<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getReturnDocumentsProfileListResponse StructType
 * @subpackage Structs
 */
class GetReturnDocumentsProfileListResponse extends AbstractStructBase
{
    /**
     * The profile
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ReturnDocumentProfileType[]
     */
    public $profile;
    /**
     * The error
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ErrorType[]
     */
    public $error;
    /**
     * Constructor method for getReturnDocumentsProfileListResponse
     * @uses GetReturnDocumentsProfileListResponse::setProfile()
     * @uses GetReturnDocumentsProfileListResponse::setError()
     * @param \StructType\ReturnDocumentProfileType[] $profile
     * @param \StructType\ErrorType[] $error
     */
    public function __construct(array $profile = array(), array $error = array())
    {
        $this
            ->setProfile($profile)
            ->setError($error);
    }
    /**
     * Get profile value
     * @return \StructType\ReturnDocumentProfileType[]|null
     */
    public function getProfile()
    {
        return $this->profile;
    }
    /**
     * This method is responsible for validating the values passed to the setProfile method
     * This method is willingly generated in order to preserve the one-line inline validation within the setProfile method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateProfileForArrayConstraintsFromSetProfile(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getReturnDocumentsProfileListResponseProfileItem) {
            // validation for constraint: itemType
            if (!$getReturnDocumentsProfileListResponseProfileItem instanceof \StructType\ReturnDocumentProfileType) {
                $invalidValues[] = is_object($getReturnDocumentsProfileListResponseProfileItem) ? get_class($getReturnDocumentsProfileListResponseProfileItem) : sprintf('%s(%s)', gettype($getReturnDocumentsProfileListResponseProfileItem), var_export($getReturnDocumentsProfileListResponseProfileItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The profile property can only contain items of type \StructType\ReturnDocumentProfileType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set profile value
     * @throws \InvalidArgumentException
     * @param \StructType\ReturnDocumentProfileType[] $profile
     * @return \StructType\GetReturnDocumentsProfileListResponse
     */
    public function setProfile(array $profile = array())
    {
        // validation for constraint: array
        if ('' !== ($profileArrayErrorMessage = self::validateProfileForArrayConstraintsFromSetProfile($profile))) {
            throw new \InvalidArgumentException($profileArrayErrorMessage, __LINE__);
        }
        $this->profile = $profile;
        return $this;
    }
    /**
     * Add item to profile value
     * @throws \InvalidArgumentException
     * @param \StructType\ReturnDocumentProfileType $item
     * @return \StructType\GetReturnDocumentsProfileListResponse
     */
    public function addToProfile(\StructType\ReturnDocumentProfileType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ReturnDocumentProfileType) {
            throw new \InvalidArgumentException(sprintf('The profile property can only contain items of type \StructType\ReturnDocumentProfileType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->profile[] = $item;
        return $this;
    }
    /**
     * Get error value
     * @return \StructType\ErrorType[]|null
     */
    public function getError()
    {
        return $this->error;
    }
    /**
     * This method is responsible for validating the values passed to the setError method
     * This method is willingly generated in order to preserve the one-line inline validation within the setError method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateErrorForArrayConstraintsFromSetError(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getReturnDocumentsProfileListResponseErrorItem) {
            // validation for constraint: itemType
            if (!$getReturnDocumentsProfileListResponseErrorItem instanceof \StructType\ErrorType) {
                $invalidValues[] = is_object($getReturnDocumentsProfileListResponseErrorItem) ? get_class($getReturnDocumentsProfileListResponseErrorItem) : sprintf('%s(%s)', gettype($getReturnDocumentsProfileListResponseErrorItem), var_export($getReturnDocumentsProfileListResponseErrorItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The error property can only contain items of type \StructType\ErrorType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set error value
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorType[] $error
     * @return \StructType\GetReturnDocumentsProfileListResponse
     */
    public function setError(array $error = array())
    {
        // validation for constraint: array
        if ('' !== ($errorArrayErrorMessage = self::validateErrorForArrayConstraintsFromSetError($error))) {
            throw new \InvalidArgumentException($errorArrayErrorMessage, __LINE__);
        }
        $this->error = $error;
        return $this;
    }
    /**
     * Add item to error value
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorType $item
     * @return \StructType\GetReturnDocumentsProfileListResponse
     */
    public function addToError(\StructType\ErrorType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ErrorType) {
            throw new \InvalidArgumentException(sprintf('The error property can only contain items of type \StructType\ErrorType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->error[] = $item;
        return $this;
    }
}
