<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for updateChecklistTemplate StructType
 * @subpackage Structs
 */
class UpdateChecklistTemplate extends AbstractStructBase
{
    /**
     * The checklistTemplate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \StructType\ChecklistTemplateType[]
     */
    public $checklistTemplate;
    /**
     * Constructor method for updateChecklistTemplate
     * @uses UpdateChecklistTemplate::setChecklistTemplate()
     * @param \StructType\ChecklistTemplateType[] $checklistTemplate
     */
    public function __construct(array $checklistTemplate = array())
    {
        $this
            ->setChecklistTemplate($checklistTemplate);
    }
    /**
     * Get checklistTemplate value
     * @return \StructType\ChecklistTemplateType[]
     */
    public function getChecklistTemplate()
    {
        return $this->checklistTemplate;
    }
    /**
     * This method is responsible for validating the values passed to the setChecklistTemplate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChecklistTemplate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChecklistTemplateForArrayConstraintsFromSetChecklistTemplate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateChecklistTemplateChecklistTemplateItem) {
            // validation for constraint: itemType
            if (!$updateChecklistTemplateChecklistTemplateItem instanceof \StructType\ChecklistTemplateType) {
                $invalidValues[] = is_object($updateChecklistTemplateChecklistTemplateItem) ? get_class($updateChecklistTemplateChecklistTemplateItem) : sprintf('%s(%s)', gettype($updateChecklistTemplateChecklistTemplateItem), var_export($updateChecklistTemplateChecklistTemplateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The checklistTemplate property can only contain items of type \StructType\ChecklistTemplateType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set checklistTemplate value
     * @throws \InvalidArgumentException
     * @param \StructType\ChecklistTemplateType[] $checklistTemplate
     * @return \StructType\UpdateChecklistTemplate
     */
    public function setChecklistTemplate(array $checklistTemplate = array())
    {
        // validation for constraint: array
        if ('' !== ($checklistTemplateArrayErrorMessage = self::validateChecklistTemplateForArrayConstraintsFromSetChecklistTemplate($checklistTemplate))) {
            throw new \InvalidArgumentException($checklistTemplateArrayErrorMessage, __LINE__);
        }
        $this->checklistTemplate = $checklistTemplate;
        return $this;
    }
    /**
     * Add item to checklistTemplate value
     * @throws \InvalidArgumentException
     * @param \StructType\ChecklistTemplateType $item
     * @return \StructType\UpdateChecklistTemplate
     */
    public function addToChecklistTemplate(\StructType\ChecklistTemplateType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ChecklistTemplateType) {
            throw new \InvalidArgumentException(sprintf('The checklistTemplate property can only contain items of type \StructType\ChecklistTemplateType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->checklistTemplate[] = $item;
        return $this;
    }
}
